
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

///SYSINFO
#define DATUM		"30.06.2008"
#define FUNKTION	"PWM Servo"
#define UHRZEIT		"12:00"
#define AUTOR		"Christof Ermer"

/*
#define UART_BAUD_RATE	57600
#define F_CPU	16000000
// 16MHZ Quarz !!

SEROVO FRQ = 61,03515625 Hz

TICK CNT = TCNT0
PWM = TCNT2
*/

/*
FUSE   "verkehrte Logik"
Note: 1. For all fuses 1 means unprogrammed while 0 means programmed.
PonyPROG CHECK-Haeckchen gesetzt bedeutet  Programmed ( Bit =  0 ) "VORSICHT"
UN-Check ( kein Hckchen= unporhrammed ( Bit = 1 )

ALL Checks OFF, DANN-->
CheCK: CKOPT BODEN   = Hckchen setzen  WDTON = unchekced = enabled
*/


#define AVR_ATmega8 //in io.h  elif defined (__AVR_ATmega8__)#  include <avr/iom8.h>

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\iom8.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\eeprom.h>	

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>

//#include <avr\twi.h> /* Note [1] */  // NEUE DATEIVERSION_STR BEUNTZEN
//#include <avr\signal.h> //#include <signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//with Hardware assigns
#include "uart.h"

#ifndef CTC1
#define CTC1 WGM12              // for compatibility with ATmega
#endif

int32_t Round(double fIn);


#if TIMER_TICK_USED == 1
void StartTimer0(void);	//0.1 Seconds  interrupt
uint32_t GetTickDifference(uint32_t ullTime);
#endif

#if USE_ERROR_FLAG == 1
uint8_t CheckTimeOut(uint32_t ulTimeNow, uint32_t uiCDiffTime );
#endif

#if USE_TOGGLE_FLAG == 1
void ToggleTEST_BIT(uint8_t ucCnt);
#endif

#if TIMER_2_PWM_ENABLED == 1
void Timer2_PWM(uint8_t u8PwmRange);
#endif



#if ADC_USED_ENABLED == 1
unsigned int ADC_10Bit(unsigned char ucChan);
#endif

#if UART_USE_ENABLED == 1
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);
void PrintFloatCR(double fVal);
void PrintLongCR(int32_t lVal);
void PrintHexCR(uint16_t uiVal);
void Print_PStrCR(PGM_P pmStr);
void PrintStrCR(const char* pStr);
void FloatToNumStr(double fVal);
void LongToNumStr(int32_t lVal);
void CheckOrder(char* pcStr);
#endif

#if   EEPROM_USED == 1
void LoadParameter(void);
int CheckEEPROM_Valid(void);
void SaveParameter(void);
#endif

#if STEPMOTOR_USED == 1
void Set_StepFRQ(float * pfVal);
void StepFRQ_OnOff(uint8_t uOnOff);
void StepMotorOn(void);
void StepMotorOff(void);
void StepMotorStop(void); 
void Set_StepMotor_Mode(uint8_t ucVal); 
void SetMotorDirection(uint8_t ucVal);
#endif

#if  LCD_4Bit_Module_USED == 1
void WriteLCD(uint8_t bLine, uint8_t *pcStr);
void WriteLCD_P(uint8_t bLine, const char * progmem_s);
#endif


///CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_VERSION[] PROGMEM = VERSION;
#if TEXT_SERVICE_USE_ENABLED == 1
//const char MCA_CRLFSTR[] PROGMEM = {13,10,0};
const char MCA_CRSTR[] PROGMEM = {13,0};
const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#endif


#if UART_ERRORMSG == 1
const char MCA_UARTErr_MSG[] PROGMEM = "UartEr";
#endif




// GLOBALE VARIABLEN 
//MSG
const char MCA_SPACE_MSG[] PROGMEM	= " ";
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
const char MCA_ISTGLEICH_MSG[] PROGMEM	= "=";
const char MCA_VALUE_MSG[] PROGMEM	= "Value";
const char MCA_BAUD_CMD[]PROGMEM = "Baud"; 


const char MCA_PING_CMD[] PROGMEM = "PING";	 //CONST ARRAY
const char MCA_SPB_CMD[]PROGMEM = "SPB"; // Set PortB
const char MCA_RPB_CMD[]PROGMEM = "RPB"; // Read PINB
const char MCA_XX_CMD[]PROGMEM = "XX"; // TEST
const char MCA_OBEN_CMD[]PROGMEM = "OBEN"; // TEST
const char MCA_UNTEN_CMD[]PROGMEM = "UNTEN"; // TEST


const char MCA_PONG_MSG[] PROGMEM	= "PONG";
const char MCA_OK_MSG[] PROGMEM	= "OK";


#if EEPROM_USED == 1
const char MCA_EEPROM_MSG[] PROGMEM	= "EEPROM";
const char MCA_SAVE_CMD[] PROGMEM = "SAVE";	 //CONST ARRAY
const char MCA_LOAD_CMD[]PROGMEM = "LOAD"; 
#endif

#if ADC_USED_ENABLED == 1
const char MCA_ADC_CMD[]PROGMEM = "ADC"; 
#endif

#if TIMER_2_PWM_ENABLED == 1
const char MCA_PWM_CMD[]PROGMEM = "PWM"; 
#endif




#if UART_USE_ENABLED == 1
volatile char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
COMMAND_TYPE gsCmd;
#endif

//ADC
float fVoltProDigit[ USED_ADC_CHANNELS];

#if KEY_USED == 1
KEYSTRUCT_TYPE gsKey;
#endif

//EEPROM VARIABLEN
//#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
//#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//uint16_t guiEEPDUMMY EEPROM_SECTION = EE_DUMMYLOAD; //avoid using lowest adress.
//ohne Prdefintion
#if EEPROM_USED == 1
uint16_t guiEEPDUMMY 			EEPROM_SECTION; //avoid using lowest adress.
EEPROM_STR_TYPE gucaEEPStr 		EEPROM_SECTION;	//String [12], FR "EEPROMVALID"siehe main.H
EEPROM_DATA_TYPE ST_EEprom_Data	EEPROM_SECTION;  //Parameterstruktur
EEPROM_DATA_TYPE gsEEprom_Data; //GLOBAL RAM ZUGRIFFSTRUCKTUR
#endif 


#if TIMER_TICK_USED == 1
//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
static uint32_t gulT0_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#endif
# if USE_ERROR_FLAG == 1
uint8_t gbErrorFlag;
#endif
//EEPROM VARIABLEN
//#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
//#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//uint16_t guiEEPDUMMY EEPROM_SECTION = EE_DUMMYLOAD; //avoid using lowest adress.
//ohne Prdefintion
//uint16_t guiEEPDUMMY EEPROM_SECTION; //avoid using lowest adress.
//EEPROM_STR_TYPE gucaEEPStr EEPROM_SECTION;	//String [12], FR "EEPROMVALID"siehe main.H
//STEPMPARTYPE gsEEPROMsStMPar EEPROM_SECTION;  //Parameterstruktur

//FLAG SECTION
//NIE LANGE IN INERRUPTS RUMWURSCHTLN STEIGT SONST AUS
//INTERRUPT
//RCO_B
/*
// ************************	****************************************
volatile SIGNAL(SIG_INTERRUPT0)// signal handler for external interrupt int0
// *******************************************************************
{//OVERFLOW_CNT_ON_INT0_MAC WIRD Freigegeben durch
sei();	//INTERRUPT ENABLE  //cli();
};



//GATE
// ************************	****************************************
volatile SIGNAL(SIG_INTERRUPT1)// signal handler for external interrupt int0
// *******************************************************************
{//GATE_ALL_EVENT_ON_INT1_MAC
sei();	//INTERRUPT ENABLE  //cli();
};
*/

#if TIMER_TICK_USED == 1
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL(TIMER0_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();
//I_SREG automtaic clear by Interrupt and Enabled by RETI
//cbi(TIMSK, TOIE2);
// 16MhZ / 1024 / 255 =	61,03515625 Hz	T= 1/f =	0.016384 ms / Interrupt
// 16MhZ / 256 / 256 =	244,140625 HZ	T= 1/f =	0,004096  ms / Interrupt
// 16MhZ / 64 / 256 =	976,5625 HZ		T= 1/f =	0,001024 ms / Interrupt
// 
gulT0_Ticks++;
/*
if( (++gulT0_Ticks) > (BEFORE_DWORD_LIMIT) ) //0xFFFFFF00 //Um einen Zhlerberlauf zu verhindern !
	{		
	gulT0_Ticks = 0;  //Wegens Ausfallgefahr bei berlauf = MINUS
	};
*/
#if UART_USE_ENABLED ==1
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};


/*
//CCCC
// ****************************************************************
SIGNAL(SIG_OUTPUT_COMPARE1A)// signal handler
//#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// *******************************************************************
{
sei();
};
*/

//EEPROM
#if   EEPROM_USED == 1
// ****************************************************************
void SaveParameter(void)
// ****************************************************************
{
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=0;
strcpy_P(gcaStr, MCA_EEPROM_MSG);
cli(); // Schalte Interrupts aus !!
//void eeprom_write_word (uint16_t *addr, uint16_t val)
eeprom_busy_wait();
eeprom_write_word( &guiEEPDUMMY, EE_DUMMYLOAD); //IN 0 NIX LADEN
//uiAdr=2;//Next Adress
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((uint8_t*)gcaStr, &gucaEEPStr, sizeof(gucaEEPStr) );
//uiAdr+=uiSize;
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((EEPROM_DATA_TYPE*)&gsEEprom_Data, &ST_EEprom_Data, sizeof(EEPROM_DATA_TYPE));
sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
uart_puts_p( MCA_EEPROM_MSG);
Print_PStrCR(MCA_SAVE_CMD);
#endif
};
#endif






#if   EEPROM_USED == 1
//EE
// *******************************************************************
int CheckEEPROM_Valid(void)
// *******************************************************************
{//return 0 = Fehler
uint16_t uiDummy; 
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=2;
//Hilfsweise gcaNumStr.
strcpy_P(gcaNumStr, MCA_EEPROM_MSG);// DAS MUSS DRINSTEHEN
cli(); // Schalte Interrupts aus !!
eeprom_busy_wait();
uiDummy = eeprom_read_word(&guiEEPDUMMY); // 1. Dummy read 
//eeprom_read_block( (char*)gcaStr, &gucaEEPStr, (strlen(gcaNumStr) + 1) );
eeprom_busy_wait();
eeprom_read_block( &gcaStr[0], &gucaEEPStr, sizeof(gucaEEPStr) );
sei(); // Schalte Interrupts wieder an !!
*(gcaStr + strlen(gcaNumStr))= 0;	// [12]-1=11	 //Terminiere
if( strncmp(gcaStr ,gcaNumStr,strlen(gcaNumStr)) ) //EEPROMVAILD --> Cmp=0
	{//!=
	//SaveParameter();
	return 0;		
	}
else
	{//OK
#if MSG_SUPPRESS_DIRECTIVE == 0
#endif
	return 1;
	};
};
#endif

#if  EEPROM_USED == 1
// ****************************************************************
void LoadParameter(void)
// ****************************************************************
{
if( CheckEEPROM_Valid() )
	{
	cli(); // Schalte Interrupts aus !!
//void  eeprom_read_block (void *buf, const void *addr, size_t n)
	eeprom_busy_wait();
	eeprom_read_block((EEPROM_DATA_TYPE*)&gsEEprom_Data, &ST_EEprom_Data, sizeof(EEPROM_DATA_TYPE));
	sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_MSG);
	Print_PStrCR( MCA_LOAD_CMD );
#endif
	};
};
#endif 

#if  TIMER_TICK_USED == 1
// *************************************
void StartTimer0(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~TIMSK_TOIE0_FLAG;	//lsche Innterrupt
TCCR0 = TCNT0 = gulT0_Ticks = 0;  //Timer MAX = TOP Compare
//ASSR &= ~(_BV(AS2)); //ASS2  CLOCK FREIGABE von QUARZ
//SFIOR |= PSR2; //RESET COUNTER
//8 Bit Timerx00);	//Timer Inhalt
// 16 MHZ  / 64 = 250000
//250000 / 256 = 3906,25  Intterrupts / Sekunde
//(1/3906,25)  = 0,000256 =  Zeit in Sek/ Interrupt
// SYSCLK_256 / 64 =  675 = 0,0014814814814814814814814814814815   mS Interrrupt
//TIMER STARTS with Presscale Select = 64
TIFR |= TIFR_TOV0_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR0 = TCCR0_CLK_64;	// 976,5625   = 0,001024 = 1MS
TIMSK |= TIMSK_TOIE0_FLAG; // BESSER == OVERFLOW 
SREG = sreg;
sei();
};
#endif


#if  TIMER_TICK_USED == 1
// ****************************************************************
uint32_t GetTickDifference(uint32_t ullTime)
// ****************************************************************
{
return (gulT0_Ticks - ullTime);
};
#endif


// *************************************
void Timer_Init(void) 
// *************************************
/* initialize timer 2 */
{
// obsolte in neuer Version timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
StartTimer0();	//8 Bit Timer 2 = MS Tick Counter
};


#if TIMER_2_PWM_ENABLED == 1
//*************************************
void Timer2_PWM(uint8_t u8PwmRange)
// *************************************
// NICHT Vergessen Das OCx BIT in DDRx auf 1 zu stellen.
{  // 8BIT TIMER T0
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//#define OC2_PWM_BIT		0x08
DDRB |= 0x08;  
TIMSK &= (~(TIMSK_TOIE2_FLAG)) & (~(TIMSK_OCIE2_FLAG));
TCNT2=  0x00;	//Timer MAX = TOP Compare
OCR2 = u8PwmRange;
//TIMER STARTS with Presscale Select =1024 16MHZ /10243 /256 = 61,03515625 Hz
TCCR2 = TCCR2_CLK_1024 | TCCR2_FAST_PWM |  TCCR2_OC2_FAST_PWM_MODE;	// CLR OC" on MAtch

SREG = sreg;
sei();
};
#endif


#if USE_TOGGLE_FLAG == 1
// ****************************************************************
void ToggleTEST_BIT(uint8_t ucCnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
uint8_t ucNN;
for(ucNN=0; ucNN < ucCnt; ucNN++)
	{
	SET_TESTBIT_MAC;
	_delay_us(1);
	CLR_TESTBIT_MAC;
	_delay_us(1);
	};
};
#endif



#if UART_USE_ENABLED == 1
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#if UART_ERRORMSG == 1
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  MCA_UARTErr_MSG );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif


// **********************************************
void FloatToNumStr(double fVal)
// *************
{
sprintf(gcaNumStr,"%.1f", fVal);
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
};



#if UART_USE_ENABLED == 1
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#if UART_USE_ENABLED == 1  //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_puts_p( MCA_CRSTR );
};


// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};


// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

#endif



#if  (UART_USE_ENABLED == 1) && (USED_HEX_CONVERSION == 1)
// *******************************************************************
void PrintHexCR(uint16_t uiVal)
// *******************************************************************
{
sprintf(gcaNumStr,"%X", uiVal);
PrintStrCR(gcaNumStr);
};
#endif



// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.caCmd, pStrTok);
	}
else
	{
	*gsCmd.caCmd = 0;
	};
gsCmd.caCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================


if( !strcasecmp_P( gsCmd.caCmd, MCA_PING_CMD)  )    //ping
	{	
	Print_PStrCR( MCA_PONG_MSG );
	};

#if EEPROM_USED == 1
if( !strcasecmp_P( gsCmd.caCmd, MCA_SAVE_CMD) )
	{
	SaveParameter();
	};


if( !strcasecmp_P( gsCmd.caCmd, MCA_LOAD_CMD) ) 
	{
	LoadParameter();
	};
#endif	


if( !strcasecmp_P( gsCmd.caCmd, MCA_SPB_CMD) ) 
	{
	PORTB = (uint8_t)gsCmd.fCmdVal_1;	
	};


if( !strcasecmp_P( gsCmd.caCmd, MCA_RPB_CMD) ) 
	{
	LongToNumStr(PINB);	
	PrintStrCR(gcaNumStr);
	};	

#if ADC_USED_ENABLED == 1
if( !strcasecmp_P( gsCmd.caCmd, MCA_ADC_CMD)  )    //ADC,0..7
	{
	uart_puts_p( MCA_ADC_CMD );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintLongCR( ADC_10Bit( gsCmd.fCmdVal_1 ) );
	};	
#endif

#if TIMER_2_PWM_ENABLED == 1
if( !strcasecmp_P( gsCmd.caCmd, MCA_PWM_CMD)  )
	{
	gsKey.ulEventTime = gulT0_Ticks;
	gsKey.ucKeyStat = KEYSTAT_PRESSED;
	ENABLE_SERVO_MAC();
	Timer2_PWM( (uint8_t)gsCmd.fCmdVal_1 );
	};	


//gsEEprom_Data.u8UpperLimit = PREDEF_SERVO_UPPERLIMIT;
//gsEEprom_Data.u8LowerLimit = PREDEF_SERVO_LOWERLIMIT;
if( !strcasecmp_P( gsCmd.caCmd, MCA_OBEN_CMD)  )
	{
	gsEEprom_Data.u8UpperLimit = (uint8_t)gsCmd.fCmdVal_1 ;
	};	


if( !strcasecmp_P( gsCmd.caCmd, MCA_UNTEN_CMD)  )
	{
	gsEEprom_Data.u8LowerLimit = (uint8_t)gsCmd.fCmdVal_1 ;
	};
#endif



#if TEST_ROUTINE_ENABLED == 1

if( !strcasecmp_P( gsCmd.caCmd, MCA_XX_CMD)  )    //ADC,0..7
	{
	uart_puts( "DDRB" );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintHexCR( DDRB);

	uart_puts( "PINB" );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintHexCR( PINB);

	uart_puts( "PORTB" );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintHexCR( PORTB);


	uart_puts( "Lower" );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintLongCR( gsEEprom_Data.u8LowerLimit);

	uart_puts( "UPPER" );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintLongCR( gsEEprom_Data.u8UpperLimit);
	};	
#endif


 #if ENDORDER_CMD_ECHO_ENABLED == 1
 Print_PStrCR( MCA_OK_MSG );   
//PrintStrCR(gsCmd.caCmd);   
#endif
 };



#if ADC_USED_ENABLED == 1
//PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnwsscht
//REM ADC4-ADC5 = 8 BIT;
//4+2 Channel. 
//  ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----
unsigned int ADC_10Bit(unsigned char ucChan)
//  ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----
{ 
 //AUCH COMPARATOR ACSR ( ACME ADEN
 ADCSRA = ADCSRA_ADEN | ADCSRA_PRESCALER_128; //ADCSRA_ADPS0 | ADCSRA_ADPS2; // Prescale 32 = 115200 Hz
 // Select pin ADC0 using MUX
 ADMUX = (ucChan & ADC_MUX_MASK);
    //Start conversion
 ADCSRA |= ADCSRA_ADSC;
    // wait until converstion completed
 while(ADCSRA & ADCSRA_ADSC ) 
	{
	wdt_reset();
	};
return    ADCW; // get converted value
};
#endif


// *******************************************************************
int main(void)
// *******************************************************************
{
//static uint16_t uiNN;
static uint32_t ullNow;
static uint8_t u8Toggle;
//static int32_t u32Cnt;

//uint32_t ulTimeCompare; //Schneller millisekunden zeitvergleich;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRB = PORTB_DDRX_OUT_MASK;
PORTB = PORTB_PRESET_PULLMASK;
DDRC = PORTC_DDRX_OUT_MASK;
PORTC = PORTC_PRESET_PULLMASK;
DDRD = PORTD_DDRX_OUT_MASK;	
PORTD = PORTD_PRESET_PULLMASK;


DISABLE_SERVO_MAC();

gsEEprom_Data.u8UpperLimit = PREDEF_SERVO_UPPERLIMIT;
gsEEprom_Data.u8LowerLimit = PREDEF_SERVO_LOWERLIMIT;


//INTERRUPT MODE EiNSTELLEMN;

//GATE_INT1_OFF_MAC;	//Ausschalten damit klare Bedingungen sind
//OVERFLOW_CNT_OFF_INT0_MAC;
// ZUM LESEN IMMER PINx verwenden
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();
#if TIMERX_USED == 1
Timer_Init();
#endif
#if TIMER_TICK_USED == 1
StartTimer0();	//8 Bit Timer 2 = MS Tick Counter
#endif

//The global interrupt flag is maintained in the I bit of the status register (SREG).
/*
cbi(ACSR, ACIE);	//Analog Comaprator Interrupt dissable
cbi(ACSR, ACI);		//Analog Comaprator Interrupt FLAG dissable
sbi(ACSR, ACD);  	//Analog Comparator PWR Disable 
*/
ACSR = _BV( ACD) | _BV( ACBG); // + BANDGAP


#if UART_USE_ENABLED == 1
ResetRxBuff();
// Initialize UART library, pass baudrate and avr cpu clock
//  with the macro UART_BAUD_SELECT()
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
#endif
sei();

//LCD...
#if LCD_4Bit_Module_USED == 1
lcd_init(LCD_DISP_ON);
 /* clear display and home cursor */
lcd_clrscr();
_delay_ms( LCD_STARTDELAY_MS );
#endif 


#if EEPROM_USED == 1
//VERIY IMPORTANT....
//BEI FEHLER (EEPROM UNBESCHRIEBEN ; LADE WERTE
if( CheckEEPROM_Valid() )//return 0 = WRONG
	{
	LoadParameter();	//EEprom VALID CHECK INCLUDED !!!
	}
else
	{
	SaveParameter();
	};
#endif

#if  USE_TOGGLE_FLAG == 1 
INIT_TESTBIT_REG_MAC;
CLR_TESTBIT_MAC;
#endif

gsKey.ulEventTime = gulT0_Ticks;

uart_puts_p( MCA_BAUD_CMD );
uart_puts_p( MCA_ISTGLEICH_MSG );
LongToNumStr(UART_BAUD_RATE);	
PrintStrCR(gcaNumStr);

// ************ MAIN LOOP FOR EVER *********************
// ************ MAIN LOOP FOR EVER *********************
ullNow = gulT0_Ticks = 0;




for (;;)  /* loop forever */
	{
	sei();
 	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

	if( ((KEY_REMOTE_POLLING_PORT & KEYS_REMOTE_MASK) != KEYS_REMOTE_MASK)  &&
		( gsKey.ucKeyStat & KEYSTAT_RELEASED )
	
	)
		{ 
		gsKey.ucKey = (KEY_REMOTE_POLLING_PORT & KEYS_REMOTE_MASK);
		gsKey.ulEventTime = gulT0_Ticks;
		gsKey.ucKeyStat |= KEYSTAT_PRESSED_DETECT;
		};
		

	if( !(gsKey.ucKey & KEY_OBEN_BIT)	&& 
		(gsKey.ucKeyStat & KEYSTAT_PRESSED_DETECT)	&&
		!(gsKey.ucKeyStat & KEYSTAT_PRESSED)			
	)
		{
#if TEST_ROUTINE_ENABLED == 1
uart_puts( "OBEN->");	
#endif	
		ENABLE_SERVO_MAC();
		Timer2_PWM(  gsEEprom_Data.u8UpperLimit );
		uart_puts_p( MCA_PWM_CMD );
		uart_puts_p( MCA_ISTGLEICH_MSG );	
		PrintLongCR( gsEEprom_Data.u8UpperLimit );
		gsKey.ucKeyStat = KEYSTAT_PRESSED;
		};

	if( !(gsKey.ucKey & KEY_UNTEN_BIT)  &&
		(gsKey.ucKeyStat & KEYSTAT_PRESSED_DETECT)	&&
		!(gsKey.ucKeyStat & KEYSTAT_PRESSED)
	)
		{
#if TEST_ROUTINE_ENABLED == 1
uart_puts( "UNTEN->");
#endif		
		ENABLE_SERVO_MAC();
		Timer2_PWM(  gsEEprom_Data.u8LowerLimit );
		uart_puts_p( MCA_PWM_CMD );
		uart_puts_p( MCA_ISTGLEICH_MSG );	
		PrintLongCR( gsEEprom_Data.u8LowerLimit );
		gsKey.ucKeyStat = KEYSTAT_PRESSED;
		};



//PULS_PER_10TEL_SEc_T2
	if( (GetTickDifference(ullNow) > PULS_PER_SECONDTICK_T0) )	//PULS_500MS_TICK_T0
		{
		ullNow = gulT0_Ticks;
		if( !(u8Toggle) )
			{
			u8Toggle = 1;
			ENABLE_LED_MAC();
			}
		else
			{
			u8Toggle = 0;
			if( !(gsKey.ucKey & KEY_OBEN_BIT) )
				{
				DISABLE_LED_MAC();
				};
			};
		}; 

	if( ((KEY_REMOTE_POLLING_PORT & KEYS_REMOTE_MASK) == KEYS_REMOTE_MASK) &&
		(GetTickDifference( gsKey.ulEventTime ) > (PULS_PER_SECONDTICK_T0 * 2)) &&
		(gsKey.ucKeyStat != KEYSTAT_RELEASED)
	)
		{
#if TEST_ROUTINE_ENABLED == 1
uart_puts( "Servo Disabel");		
#endif
		gsKey.ucKeyStat = KEYSTAT_RELEASED;
		DISABLE_SERVO_MAC();
		};
	

#if UART_USE_ENABLED ==1
	UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif

	};
};
// ******************* MAIN END ********************************************
